<?php

define("USE_PHP_AUTH",true);
define("AUTH_USERS",serialize(array(0=>array("username"=>"admin","password"=>"test"),1=>array("username"=>"admin2","password"=>"test123"))));

#2021-04-01 cc: Use either IP or MAC Address if on same subnet
define("USE_MAC",false);

define("IP_PATH","/bin/ip");

#2021-04-01 cc: Use this IPSET - note has to bee already initialized
define("IPSET_NAME","foo");
#created e.g.  ipset create foo hash:ip timeout 3600 / or hash:mac if using mac / or bitmap:ip,mac see man ipset for further details USE_MAC would be false 
define("IPSET_PATH","/sbin/ipset");
define("IPSET_TIMEOUT","3600");

#sudoers e.g. www-data  ALL=(ALL)NOPASSWD:/sbin/ipset -exist add *
define("SUDO_PATH","/usr/bin/sudo");


function checkRequirements()
{
	if(!is_executable(IPSET_PATH))
	{
		die("IPSET Path not found");
	}

	if(USE_MAC===true && !is_executable(IP_PATH) )
	{
		die("Cannot find ip utility for discovering MAC address");
	}
	
	if(!is_executable(SUDO_PATH))
	{
		die("Sudo not found or not executable");
	}

       

}


function checkAuth()
{
   if(USE_PHP_AUTH===true)
   {

     $user = $_SERVER['PHP_AUTH_USER'];
     $pass = $_SERVER['PHP_AUTH_PW'];

     $authArray=unserialize(AUTH_USERS);

     if(!isset($user) || !isset($pass))
     {
	     header('WWW-Authenticate: Basic realm="Bitte Authentifizieren"');
             header('HTTP/1.0 401 Unauthorized');
	     die("Not Authorized");

     }

     for($i=0; $i < count($authArray) ; $i++)
     {
	     if($user == $authArray[$i]["username"] && $pass == $authArray[$i]["password"])
	     {
		     openlog("auth_attempt",LOG_PID);
		     syslog(LOG_INFO,"authorizer-php user: $user login successfully");
		     return true;

	     }


     }
     openlog("auth_attempt",LOG_PID);
     syslog(LOG_INFO,"authorizer-php user: $user login incorrect");

     header('WWW-Authenticate: Basic realm="Bitte Authentifizieren"');
     header('HTTP/1.0 401 Unauthorized');

     die("Not Authorized");


       
   }
   else
   {
	   if(!isset($_SERVER['PHP_AUTH_USER']))
	   {
		   die("Authentication is mandatory for this to run");
	   }

   }



}

function getMacAddress($ip)
{

	exec(IP_PATH." neigh ls ".$ip,$returnOutput);

	if(count($returnOutput)!=1)
	{
		return false;
	}
        
        $returnOutput=explode(" ",$returnOutput[0]);	

	if(isset($returnOutput[4]))
	{
		return $returnOutput[4];
	}

	return false;

}





	checkRequirements();
        checkAuth();
        if(USE_MAC===true)
	{
	$remoteRessource=getMacAddress($_SERVER['REMOTE_ADDR']);
	}
	else
	{
		$remoteRessource=$_SERVER['REMOTE_ADDR'];
	}
	$username=$_SERVER['PHP_AUTH_USER'];


	exec("sudo ".IPSET_PATH." -exist add ".IPSET_NAME." ".$remoteRessource." timeout ".IPSET_TIMEOUT,$returnOutput,$returnStatus);

	if($returnStatus!==0)
	{
		die("Could not process auth request: "."sudo ".IPSET_PATH." -exist add ".IPSET_NAME." ".$remoteRessource." timeout ".IPSET_TIMEOUT);

	}


?>
<html>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Christian Czeczil">
    <link rel="icon" href="../../favicon.ico">

    <title>Authorizer</title>

    <!-- Bootstrap core CSS -->
    <link href="bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <!-- Bootstrap theme -->
    <link href="boostrap/css/bootstrap-theme.min.css" rel="stylesheet">
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <link href="assets/css/ie10-viewport-bug-workaround.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="theme.css" rel="stylesheet">


  </head>


<body>

  <div class="container theme-showcase" role="main">

    <!-- Main jumbotron for a primary marketing message or call to action -->
      <div class="jumbotron">
        <h1>Successfully authenticated</h1>
      </div>

   <table class="table table-hover">
   <tr><td>Username: </td><td><strong> <?php echo $username ?> </strong></td></tr>
   <tr><td>Access Deadline: </td><td><strong><?php echo date("Y-m-d H:i:s",time()+IPSET_TIMEOUT) ?></strong></td></tr>
   </table>



</body>
</html>
